﻿var olFolderTasks = 13;
var olTaskItem = 3;
var spacer = 16;

var tasks_folder;
var col_tasks;
var outlook;
var old_t = -1;

// hook call so our custom menu function is called 
pluginHelper.onAddCustomMenuItems = addCustomMenuItems


function view_onOpen()
{
	try {
		outlook = new ActiveXObject("Outlook.Application");
		var ns = outlook.GetNameSpace("MAPI");
		tasks_folder = ns.GetDefaultFolder(olFolderTasks);
		refresh();
	} catch(e) {
		alert("Failed to find Outlook on your system\nor failed opening the Outlook MAPI namespace\n\nThis gadget requires Microsoft Outlook to be installed");
		event.returnValue = false;
	}
	task_edit.color = "#449944";
}

function refresh()
{
	view_onSize();

	task_div.removeAllElements();

	col_tasks = tasks_folder.Items;
	col_tasks.Sort("[Status][Subject]", false);
	//col_tasks.Sort("[Status][Importance]", false);
	
	for(t = 1; t <= col_tasks.Count; t++) {
		var task = col_tasks.Item(t);
		var yoff = (t*spacer) - 16;
		bold = "false";
		if(task.Status == 2) {
			color = "#AAAAAA";
			strike = "true";
			task_div.appendElement("<img onmouseover='task_hover("+t+")' enabled='true' onClick='task_click("+t+")' y='"+yoff+"' src='tick.png'/>");
			task_div.appendElement("<img onClick='' onmouseover='task_hover("+t+")' enabled='true' y='"+yoff+"' x='16' src='pri_none.png'/>");
		} else {
			switch(task.Importance) {
				case 0:
				  task_div.appendElement("<img onClick='task_imp_click("+t+")' onmouseover='task_hover("+t+")' enabled='true' y='"+yoff+"' x='16' src='pri_low.png'/>");
				  color = "#6666dd"; break;
				case 1:
				  task_div.appendElement("<img onClick='task_imp_click("+t+")' onmouseover='task_hover("+t+")' enabled='true' y='"+yoff+"' x='16' src='pri_none.png'/>");
				  color = "#000000"; break;
				case 2:
				  task_div.appendElement("<img onClick='task_imp_click("+t+")' onmouseover='task_hover("+t+")' enabled='true' y='"+yoff+"' x='16' src='pri_hi.png'/>");
				  color = "#FF0000"; bold = "true"; break;
				default:
				  color = "#000000";
			}
			strike = "false";
			task_div.appendElement("<img onmouseover='task_hover("+t+")' enabled='true' onClick='task_click("+t+")' y='"+yoff+"' src='notick.png'/>");

		}
		task_div.appendElement("<label bold='"+bold+"' width='200' onmouseover='task_hover("+t+")' strikeout='"+strike+"' tooltip='' font='Calibri' color='"+color+"' size='10' enabled='true' x='24' y='"+yoff+"' ondblclick='task_dblclick("+t+")'>"+task.Subject+"</label>");
		task_div.appendElement("<img height='8' visible='false' enabled='true' name='del_img_"+t+"' width='8' x='"+(view.width-10)+"' y='"+(yoff+4)+"' onclick='task_del("+t+")' src='del.png'/>");
	}
}


function task_click(t)
{
	var task = col_tasks.item(t);
	if(task.Status == 2) {
		task.Status = 0;
	} else {
		task.MarkComplete();
	}
	old_t = -1;
	task.Save();
	refresh();
}

function task_dblclick(t)
{
	var task = col_tasks.item(t);
	task.Display();
}

function task_hover(t)
{
	var yoff = (t*spacer) - 16+20;
	hover_div.y = yoff;
	if(old_t > -1) task_div.children.item("del_img_"+old_t).visible = false;
	task_div.children.item("del_img_"+t).visible = true;
	old_t = t;
}

function task_del(t)
{
	var task = col_tasks.item(t);
	task.Delete();
	old_t = -1;
	refresh();
}

function task_imp_click(t)
{
	var task = col_tasks.item(t);
	imp = task.Importance;
	imp++;
	if(imp > 2) imp = 0;
	task.Importance = imp;
	task.Save();
	refresh();
}

function view_onSize()
{
	task_div.width = view.width;
	task_edit.width = view.width;
	task_edit.italic = true;
	task_edit.color = "#449944";
	task_div.height = view.height+20;
	hover_div.width = view.width;
}

function add_focus()
{
	task_edit.value = "";
	task_edit.italic = false;
	task_edit.color = "#000000";
}

function add_press()
{
	if(event.keyCode == 13) {
		var t = outlook.CreateItem(olTaskItem); 
		t.Subject = task_edit.value;
		t.Save();
		task_edit.value = "Add new task item...";
		task_div.focus();
		refresh();
	}
}

//
// add menu items to the main gadget menu
//
function addCustomMenuItems(menu)
{
	menu.AddItem("Refresh", 0, refresh);
}